
        SECTION TEXT
********************** several relational macros *******************************
*########## note that this series of macros is all b,w,l sensitive ###########
*########### if there are two params, PARAM 1 MUST BE A REGISTER ##################
*                 *** some of these are untested ***
* these macros correct for the 68,000 inversion problem, so the relational
* oprator in the debug window will read properly.

; call:  gogtr a,b,label
; IF a > b THEN GOTO label
gogtr   MACRO
        cmp.\0  \2,\1
        bgt     \3
        ENDM
;.....................................................        
; call:goless a,b,mylabel
; IF a < b THEN GOTO  mylabel
goless  MACRO
        cmp.\0  \2,\1
        blt     \3
        ENDM
;......................................
;  call:   golesseql    a,b,mylabel       
;  IF a <= b THEN GOTO mylabel
golesseql MACRO
        cmp.\0  \2,\1
        ble     \3
        ENDM
;..................................
; call goeql  a,b,mylabel
; IF a = b THEN GOTO mylabel
goeql   MACRO
        cmp.\0  \2,\1
        beq     \3
        ENDM
;.................................
; call: goneq   a,b,mylabel
; IFa <> b THEN GOTO mylabel
goneq   MACRO
        cmp.\0  \2,\1
        bne     \3
        ENDM
;................................
; call: gominus a,mylabel
; IF a < 0 THEN GOTO mylabel
gominus MACRO
        tst.\0  \1
        bmi     mylabel
        ENDM
;...............................        
; call: gonotneg        a,mylabel                                
; IF a > -1 THEN GOTO mylabel
gonotneg MACRO
        tst.\0  \1
        bpl     \3
;..................................
; call: gogtr0   a,mylabel
; IF a > 0 THEN GOTO mylabel
gogtr0  MACRO
        tst.\0  \1
        bmi     \@
        beq     \@
        bra     mylabel
\@      
        ENDM                
;................................................
;  call: gogtreql   a,b,mylabel
;  IF a >= b THEN GOTO mylabel
gogtreql MACRO
        cmp.\0  \2,\1
        bge     \3
        ENDM        
********************** pop stack and return ******************
* remove n bytes from the stack and perform the  return ritual
* to return to a Pascal caller (or any well-behaved caller)
* sample call : return   10             * remove 10 bytes of parameters
return  MACRO
        move.l  (sp),\1(sp)
        add.l   #\1,sp
        rts
        ENDM
******************************** div32 macro **************************
; equivalent declaration:   FUNCTION div32(dividend,divisor:long_integer):long_integer;
;            sample call:   div32 a,b
div32   MACRO
        move.l  \1,-(sp)
        move.l  \2,-(sp)
        bsr     div32
        ENDM 
*********************** modulus macro *************************
; compute n MOD m
; equivalent declaration FUNCTION mod32(n,m:long_integer):long_integer;
;           sample call:  mod32 1983,4        *leap year?
; as a side effect, div32 stores the remainder, with the proper sign affixed,
; in a cell cleverly named 'remainder'.
; note that the sign for modulus is the same as that for division.
mod32   MACRO
        div32   \1,\2
        move.l  remainder,d0
        ENDM
******************************* absolute value *********************        
; put the absolute value of param 1 in param2 (a register)
; call       :  abs(x:long_integer;  register_id:d1..d7)
; sample call:  abs  8(sp),d3
abs     MACRO
        move.l  \1,\2
;       condx code is set
        bpl     \@
        neg.l   \2
\@                
        ENDM
;=========================== minimum of a,b =====================
;************************ B, W, L sensitive *********************
; p1 and p2 are register numbers. put the smaller value in p1 and the other 
; one in p2.
; sample call:   min(d1,d4)
min     MACRO
        cmp.\0  \1,\2
        bgt     \@
        exg     \1,\2                   always LONG
\@      
        ENDM
**************************** mpy32 ******************************      
; multiply two 32-bit signed integers.  Checks for overflow are not performed.
; call: FUNCTION mpy32(x,y:long_integer):long_integer
mpy32   MACRO
        move.l  \1,-(sp)
        move.l  \2,-(sp)
        bsr     mpy32
        ENDM
